loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();
loadfile("luaScripts/Fishing_Func.inc")();

CurrentLure = "";
CurrentLureIndex=2;
PlayersLures={};
StatusLog={};
PreviousLog={};
CurrentTime="";
templog = {};
gui_log_fish = {};

function LureSetup()
	if CurrentLure == "" then
		--Setup Lures.
		
		arrowcheck = false;
		srReadScreen();
		
		arrow=srFindImage("fishing/menu_uparrow.png");
		if arrow then
			srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			lsSleep(100);
		end
		
		
		for i = 1, #Lures do
			lsSleep(50);
			
			lure = srFindImage("fishing/" .. Lures[i]);
			if lure then
				table.insert(PlayersLures,i);
			end
			
			if i > 10 and arrowcheck==false then
				arrowcheck=true;
				--Click down arrow if there is one.
				
				arrow=srFindImage("fishing/menu_downarrow.png");
				if not arrow then
					arrow=srFindImage("fishing/menu_uparrow.png");
					if arrow then
						srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
					end
				else
					srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
				end
				srReadScreen();
			end
			
		end
		
		arrow=srFindImage("fishing/menu_uparrow.png");
		if arrow then
			srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
		end
		
		
	else
		--Get Current Lure, and advance to the next.
		
		if CurrentLureIndex == table.getn(PlayersLures) then
			--On last lure, rewind!
			CurrentLureIndex=1;
			arrow=srFindImage("fishing/menu_uparrow.png");
			if arrow then
				srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			end
		elseif CurrentLureIndex==10 then
			--Check down arrow
			arrow=srFindImage("fishing/menu_downarrow.png");
			if arrow then
				srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			end
			
			--
			CurrentLureIndex = CurrentLureIndex +1;
		else
			CurrentLureIndex = CurrentLureIndex +1;
		end
	
	end
	
	lsSleep(250);
end

function GetLure()
	srReadScreen();
	lure = srFindImage("fishing/" .. Lures[PlayersLures[CurrentLureIndex]]);
	if not lure then
		--Failed to find lure
		error("cant find lure");
	else
		slure = Lures[PlayersLures[CurrentLureIndex]];
		slure = string.sub(slure,string.find(slure,"_")+1,string.len(slure) - 4);
		--statusScreen("Using Lure " .. slure);
		return slure
	end
end

function UseLure()
	--Time Stamp
	

	CurrentTime = GetTime();
	
	if CurrentLureIndex > 15 then
		srReadScreen();
		down = srFindImage("fishing/Menu_DownArrow.png");
		if down then
			srClickMouseNoMove(down[0]+3,down[1]+3);
			lsSleep(500);
		end
	elseif CurrentLureIndex > #Lures then
		CurrentLureIndex = 1;
		srReadScreen();
		up = srFindImage("fishing/Menu_UpArrow.png");
		if up then
			srClickMouseNoMove(up[0]+3,up[1]+3);
			lsSleep(500);
		end
	end
	
	--Find Lure/Use
	srReadScreen();
	lure = srFindImage("fishing/" .. Lures[PlayersLures[CurrentLureIndex]]);
	if not lure then
		--Failed to find lure
		error("cant find lure");
	else
		srClickMouseNoMove(lure[0]+3,lure[1]+3);
		slure = Lures[PlayersLures[CurrentLureIndex]];
		slure = string.sub(slure,string.find(slure,"_")+1,string.len(slure) - 4);
		CurrentLure = slure;
		--statusScreen("Using Lure " .. slure);
		table.insert(StatusLog,"[Lure]");
		
		lsSleep(100);
		srReadScreen();
		--Insect Menu
		menuoption = srFindImage("fishing/Lure_Menu_Preserved.png");
		if menuoption then
			srClickMouseNoMove(menuoption[0]+5,menuoption[1]+5);
		end
	end
	
	gui_refresh();
	

end

function ChatReadFish()
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	
	--Caught Something..  Find Fish Details
	Sfish = "";
				
	for i = 1, #CL_Fish do
	ChatFish = srFindImageInRange("Fishing/" .. CL_Fish[i],Coords[0] ,Coords[1],500,25);
	if ChatFish then
		Sfish = string.sub(CL_Fish[i],string.find(CL_Fish[i],"Fish_") + 5,string.len(CL_Fish[i]) - 4);
		break;
	end
					
	end
				
	if  string.len(Sfish) < 1 then
		error("unknown fish");
	end
				
	--Find Size
	for i = #CL_Number,1,-1 do
		ChatSize =  srFindImageInRange("fishing/" .. CL_Number[i],Coords[0],Coords[1],300,25);
		if ChatSize then
			SNum = string.sub(CL_Number[i],string.find(CL_Number[i],"_") + 1, string.len(CL_Number[i]) - 4);
			break;
		end
	end
				
	return("[" .. SNum .. "][" .. Sfish .. "]");
	
end


function LogReadFish(lostlure)
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	--Caught Something..  Find Fish Details
	Sfish = "";
				
	for i = 1, #CL_Fish do
	ChatFish = srFindImageInRange("Fishing/" .. CL_Fish[i],Coords[0] ,Coords[1],500,25);
	if ChatFish then
		Sfish = string.sub(CL_Fish[i],string.find(CL_Fish[i],"Fish_") + 5,string.len(CL_Fish[i]) - 4);
		break;
	end
					
	end
				
	if  string.len(Sfish) < 1 then
		error("unknown fish");
	end
				
	--Find Size
	for i = #CL_Number,1,-1 do
		ChatSize =  srFindImageInRange("fishing/" .. CL_Number[i],Coords[0],Coords[1],300,25);
		if ChatSize then
			SNum = string.sub(CL_Number[i],string.find(CL_Number[i],"_") + 1, string.len(CL_Number[i]) - 4);
			break;
		end
	end
				
				
	--statusScreen("Caught " .. Sfish .. " Size " .. SNum);
	
	table.insert(StatusLog,"[Time][" .. Sfish .. "][" .. SNum .. "]");

end

function Readchatlog()
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	--Determine What Happened
	test = srFindImageInRange("fishing/ChatLog_UsingALure.png",Coords[0],Coords[1],350,25);
	if not test then
		test = srFindImageInRange("fishing/ChatLog_NoFishBit.png",Coords[0],Coords[1],200,25);
		if not test then
			test = srFindImageInRange("fishing/ChatLog_CaughtA.png",Coords[0],Coords[1],350,25);
			if not test then
				test = srFindImageInRange("fishing/Chatlog_AlmostCaughtStrange.png",Coords[0],Coords[1],400,25);
				if not test then
					test = srFindImageInRange("fishing/Chat_ThoughYouLost.png",Coords[0],Coords[1],350,25);
					if not test then
						LogReadFish(true);
					else
						test = srFindImageInRange("fishing/Chatlog_AlmostCaughtUnusual.png",Coords[0],Coords[1],350,25);
						if not test then
							error("chat unknown");
						else
							table.insert(StatusLog,"SpeedyFish");
							WriteFishLog("SpeedyFish" .. "\n");
						end
					end
					
				else
					--Clumbsy Fish
					table.insert(StatusLog,"ClumbsyFish");
					WriteFishLog("ClumbsyFish" .. "\n");
				end
			else
				--Caught Fish
				LogReadFish();
			end
		else
			-- No Fish Bit
			table.insert(StatusLog,"NoBit");
		end
	else
		--New Lure
	end
	
end

function findchat(line)
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	if line and line > 0 then
		Coords = imgs[(#imgs) - line];
	end
	
	
	--Determine What Happened
	test = srFindImageInRange("fishing/ChatLog_UsingALure.png",Coords[0],Coords[1],350,25);
	if not test then
		test = srFindImageInRange("fishing/ChatLog_NoFishBit.png",Coords[0],Coords[1],200,25);
		if not test then
			test = srFindImageInRange("fishing/Chatlog_AlmostCaughtStrange.png",Coords[0],Coords[1],500,30);
			if not test then
				
				test = srFindImageInRange("fishing/Chatlog_AlmostCaughtUnusual.png",Coords[0],Coords[1],500,30);
				if not test then
					test = srFindImageInRange("fishing/ChatLog_CaughtA.png",Coords[0],Coords[1],350,25);
					if not test then
						error("chat unknown");
					else
						return "Caught"
					end
				else
					return "Unusual"

				end
			else
				return "Strange";
			end
		else
			-- No Fish Bit
			return "NoFishBit"
		end
	else
		--New Lure
		return "Lure"
	end
	

end


function GetTime()
	--Open Menu
	srKeyEvent(string.char(27));
	lsSleep(500);
	
	--Find Special
	srReadScreen();
	menu = srFindImage("fishing/Menu_Special.png");
	
	if menu then
		srClickMouseNoMove(menu[0]+3,menu[1]+3);
		
		lsSleep(500);
		srReadScreen();
		
		menu = srFindImage("fishing/Menu_WhatTime.png");
		if menu then
			srClickMouseNoMove(menu[0]+3,menu[1]+3);
			lsSleep(500);
		end
	end
	
	
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	for i = #CL_Time, 1, -1 do
		Stime = srFindImageInRange("fishing/" .. CL_Time[i],Coords[0],Coords[1],400,25);
		if Stime then
			Hour = string.sub(CL_Time[i],string.find(CL_Time[i],"ime_")+4,string.len(CL_Time[i])-4);
			
			AM = srFindImageInRange("fishing/Chatlog_Time_AM.png",Coords[0],Coords[1],400,25);
			if AM then
				CurrentTime=(Hour .. "AM");
				return (Hour .. "AM");
			else
				PM = srFindImageInRange("fishing/chatlog_time_PM.png",Coords[0],Coords[1],400,25);
				if PM then
					CurrentTime=(Hour .. "PM");
					return (Hour .. "PM");
				end
			end
		end
	end
end

function gui_refresh()
	lsDoFrame();
	lsPrintWrapped(10, 5, 0, lsScreenX - 20, 1, 1, 0xFFFFFFff, "Using Lure: " .. CurrentLure);
	lsPrintWrapped(10, 25, 0, lsScreenX - 20, 1, 1, 0xFFFFFFff, "Time: " .. CurrentTime);
	
	if gui_log_fish then
		for i = 1, table.getn(gui_log_fish) do
			lsPrintWrapped(10, 50 + (20*i), 0, lsScreenX - 20, 1, 1, 0xFFFFFFff,gui_log_fish[i]);
		end

	end
end

function doit()
	askForWindow("");
	LureSetup();
	UseLure();
	lsSleep(1500);

	
	
	while 1 do
		
		checkBreak();
		srReadScreen();
		cast = srFindImage("fishing/Button_Fish.png");
		if not cast then
			error("cannot find fishing button");
		end
		
		
		if templog == nil then
			currentline = findchat();
			
			if currentline == "Lure" then
				table.insert(templog,GetLure());
			else
				CurrentLureIndex = CurrentLureIndex + 1;
				UseLure();
			end
		else
			srClickMouseNoMove(cast[0]+3,cast[1]+3);

			while findchat(table.getn(templog)) == "Lure" do
				lsSleep(2000);
				checkBreak();
			end
			
			
			newchat = findchat();
			if newchat == "NoFishBit" then
				--New Lure, Reset
				templog = {};
				CurrentLureIndex = CurrentLureIndex + 1;
				UseLure();
			elseif newchat == "Caught" then
				fish = ChatReadFish();
				table.insert(templog,ChatReadFish());
				table.insert(gui_log_fish,"[" .. CurrentTime .. "]" .. ChatReadFish());
				WriteFishLog("[" .. CurrentLure .. "][" .. CurrentTime .. "]" .. ChatReadFish() .. "\n");
				gui_refresh();
			else
				table.insert(templog,newchat);
				WriteFishLog(newchat .. "\n");
				table.insert(gui_log_fish,"[" .. CurrentTime .. "][" .. newchat .. "]");
				gui_refresh();
			end
			
			if table.getn(templog) > 3 then
				templog = {};
				CurrentLureIndex = CurrentLureIndex + 1;
				UseLure();
			end

		end		
		gui_refresh();
	end

end
	